Attribute VB_Name = "VBgauss"

Public Sub VBclear(ByVal dataset As String)
    Dim file1, file2 As String
    Dim f1, f2 As Byte
    
    If InStr(1, dataset, ":\", vbTextCompare) = 0 Then
        dataset = CurDir + "\" + dataset
    End If
    
    file1 = dataset + ".inf"
    file2 = dataset + ".asc"
    
    'Kill file1
    
    f1 = FreeFile
    
    Open file1 For Output As #f1
    Close #f1
        
    'Kill file2
    
    f2 = FreeFile
    Open file2 For Output As #f2
    Close #f2
    
    
End Sub

Public Sub VBput(ByVal dataset As String, ByRef x() As Double, _
                 ByVal name As String)
    Dim file1, file2 As String
    Dim f1, f2 As Byte
    Dim r, c, N As Integer
    Dim i, j As Integer
    
    If InStr(1, dataset, ":\", vbTextCompare) = 0 Then
        dataset = CurDir + "\" + dataset
    End If
    
    file1 = dataset + ".inf"
    file2 = dataset + ".asc"
    
    f1 = FreeFile
    f2 = FreeFile
    
    r = UBound(x, 1)
    c = UBound(x, 2)
    N = r * c
        
    Open file1 For Append As #f1
    Write #f1, name, r, c
    Close #f1
    
    Open file2 For Append As #f2
    For j = 1 To c
        For i = 1 To r
            Write #f2, x(i, j)
        Next i
    Next j
    Close #f2
    
End Sub

Public Sub VBread(ByVal dataset As String, ByVal name As String, _
                  ByRef x() As Double)
    Dim file1, file2 As String
    Dim f1, f2 As Byte
    Dim name_ As String
    Dim r, c, pos As Integer
    Dim i, j As Integer
    Dim xi As Double
    
    If InStr(1, dataset, ":\", vbTextCompare) = 0 Then
        dataset = CurDir + "\" + dataset
    End If
    
    file1 = dataset + ".inf"
    file2 = dataset + ".asc"
    
    f1 = FreeFile
    f2 = FreeFile
    
    Open file1 For Input As #f1
    
    pos = 0
    
    Do While Not EOF(f1)
    
        Input #f1, name_, r, c
        
        If name_ = name Then
            Exit Do
        End If
        
        pos = pos + r * c
        
    Loop
        
    Close #f1
    
    Open file2 For Input As #f2
    
    For i = 1 To pos
        Input #f2, xi
    Next i
    
    ReDim x(1 To r, 1 To c)
    
    For j = 1 To c
        For i = 1 To r
            Input #f2, x(i, j)
        Next i
    Next j
    
    Close #f2
    
End Sub
