new;
library option,pgraph;


S0 = seqa(85,1,31);
K = 100;
sigma = 0.20;
tau = 90/365;
r = 0.08;
b = 0;

_Option_Type = "put";

P = EuropeanBS(S0,K,sigma,tau,b,r);

V0 = sigma^2; /* V0 = 0.04 */
kappa = 1;
theta = V0;
sigmaV = 2.5;
rho = 0;
lambda = 0;

_Option_Tol = 1e-4;
_Option_NumIters = 10;

{P1,retcode} = EuropeanHeston(S0,K,V0,tau,b,r,
                                     kappa,theta,sigmaV,rho,lambda);

theta = 0.3^2;
rho = 0;

{P2,retcode} = EuropeanHeston(S0,K,V0,tau,b,r,
                                     kappa,theta,sigmaV,rho,lambda);

rho = 0.9;

{P3,retcode} = EuropeanHeston(S0,K,V0,tau,b,r,
                                     kappa,theta,sigmaV,rho,lambda);

rho = -0.9;

{P4,retcode} = EuropeanHeston(S0,K,V0,tau,b,r,
                                     kappa,theta,sigmaV,rho,lambda);

theta = 0.1^2;
rho = 0.9;

{P5,retcode} = EuropeanHeston(S0,K,V0,tau,b,r,
                                     kappa,theta,sigmaV,rho,lambda);

graphset;
  _pdate = ""; _pnum = 2; _plctrl = 3; _pstype = 8|9|9|10|11|10; _psymsiz = 2.5;
  _pltype = 6|6|1|1|1|3;
  fonts("simplex simgrma");
  title("Heston model");
  xlabel("S]0[");
  ylabel("Put");  
  _plegstr = "BS\000\202Q\201 = 0.2[2] -- \202r\201 = 0"\
             "\000\202Q\201 = 0.3[2] -- \202r\201 = 0"\
             "\000\202Q\201 = 0.3[2] -- \202r\201 = 0.9"\
             "\000\202Q\201 = 0.3[2] -- \202r\201 = -0.9"\
             "\000\202Q\201 = 0.1[2] -- \202r\201 = 0.9";
  _plegctl = {2 5 5 4};
  xtics(85,115,5,0);
  graphprt("-c=1 -cf=option4.eps");
  xy(S0,P~P1~P2~P3~P4~P5);