new;
library option,pgraph;


load oam_c;

Nobs = rows(oam_c);
b = 0;

_Option_impVol = "NR"; /* _Option_impVol = "bi-section"; */
_Option_Type = "call";

tau = zeros(Nobs,1);
i = 1;
do until i > Nobs;
  tau[i] =  option_etdays(oam_c[i,1],oam_c[i,3]);
  i = i + 1;
endo;

F0 = oam_c[.,6];
K = oam_c[.,4];
C = oam_c[.,5];
r = oam_c[.,7]/100;

t0 = hsec;
impVol = EuropeanBS_impVol(F0,K,tau,b,r,C);
t1 = hsec;

sigma = 0.006;
impLambda = zeros(Nobs,1);

_qn_PrintIters = 0;
__output = 0;

i = 1;
do until i > Nobs;

  proc rss(lambda);
    local u;
    u = EuropeanCCL(oam_c[i,6],oam_c[i,4],sigma,
                    tau[i],b,oam_c[i,7]/100,lambda) - oam_c[i,5];
    retp(u^2);
  endp;

  {impLambda[i],f0,g0,retcode} = QNewton(&rss,5);

  i = i + 1;
endo;
 
  
graphset;
  _pnum = 2; _pdate = ""; _pltype = 6|4;
  fonts("simplex simgrma");
  title("\202s\201]implied[(BS)");
  let lab = "1992" "1993" "1994" "1995" "1996";
  asclabel(lab,0);
  xtics(1,Nobs,Nobs/4,11);
  graphprt("-c=1 -cf=option6a.eps");
  xy(seqa(1,1,Nobs),impVol);

  title("\202l\201]implied[(CCL)");
  graphprt("-c=1 -cf=option6b.eps");
  xy(seqa(1,1,Nobs),impLambda);

