new;

dlibrary tridiag.dll;

N = 20000;

a = rndn(N,1); b = rndn(N,1); c = rndn(N,1);
d = a + b + c;

t1 = hsec;
x1 = TDGsolve(a,b,c,d);
t2 = hsec;

x2 = zeros(N,1); bprime = zeros(N,1); dprime = zeros(N,1);

t3 = hsec;
dllcall _dllTDGSolve(a,b,c,d,N,x2,bprime,dprime);
t4 = hsec;

t5 = hsec;
x3 = TDGsolve2(a,b,c,d);
t6 = hsec;



print (t2-t1);
print (t4-t3);
print (t6-t5);

proc (1) = TDGsolve(a,b,c,d);
  local N,x,bprime,dprime,i,w;

  N = rows(b);

  x = zeros(N,1); bprime = zeros(N,1); dprime = zeros(N,1);
  bprime[N] = b[N]; dprime[N] = d[N];

  i = N - 1;
  do while i > 0;
    w = c[i]/bprime[i+1];
    bprime[i] = b[i] - w*a[i+1];
    dprime[i] = d[i] - w*dprime[i+1];
    i = i - 1;
  endo;

  x[1] = dprime[1]/bprime[1];

  i = 2;
  do until i > N;
    x[i] = (dprime[i]-a[i]*x[i-1])/bprime[i];
    i = i + 1;
  endo;
  
  retp(x);
endp;



proc (1) = TDGsolve2(a,b,c,d);
  local N,x,bprime,dprime,i,w;

  N = rows(b);

  x = zeros(N,1); bprime = zeros(N,1); dprime = zeros(N,1);
  bprime[N] = b[N]; dprime[N] = d[N];

  for i(N-1,1,-1);
    w = c[i]/bprime[i+1];
    bprime[i] = b[i] - w*a[i+1];
    dprime[i] = d[i] - w*dprime[i+1];
  endfor;

  x[1] = dprime[1]/bprime[1];

  for i(2,N,1);
    x[i] = (dprime[i]-a[i]*x[i-1])/bprime[i];
  endfor;
  
  retp(x);
endp;



