new;
library tsm,optmum,pgraph;
TSMset;


@<--- Data --->@

N = 255;
t = seqa(0,6*pi/N,N+1);
x1 = sin(t);
x2 = cos(2*t);
x3 = rndn(N+1,1)*0.20;

y = x1 + x2 + x3;


@<--- wavelet transform --->@

{H,G,Htilde,Gtilde} = Coiflet(2);

_wcenter = 0;
w = wt(y,H,G,0);

w1 = substute(w, abs(w) .> 1, 0);
y1 = iwt(w1,Htilde,Gtilde,0);

w2 = substute(w, abs(w) .< 1, 0);
y2 = iwt(w2,Htilde,Gtilde,0);


graphset;
  begwind;
  window(2,2,0);
    _pdate = ""; _pnum = 2; _pnumht = 0.25;

  setwind(1);
    ytics(-2,1.5,0.5,0);
    xtics(0,20,5,0);
    xy(t,y);

  setwind(2);
    xtics(0,rows(w),32,0);
    ytics(-1,1,0.5,0);
    bar(seqa(1,1,rows(w)),w1);

  setwind(3);
    ytics(-5,5,1,0);
    bar(seqa(1,1,rows(w)),w2);

  setwind(4);
    ytics(-2,1.5,0.5,0);
    xtics(0,20,5,0);
    xy(t,y1~y2);

    graphprt("-c=1 -cf=tsm5a.eps");

  endwind;

