VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmVB1 
   Caption         =   "Linear Algebra ToolBox"
   ClientHeight    =   5055
   ClientLeft      =   1995
   ClientTop       =   1470
   ClientWidth     =   7395
   LinkTopic       =   "Form1"
   ScaleHeight     =   5055
   ScaleWidth      =   7395
   Begin VB.CommandButton cmdData 
      Caption         =   "Enter Data"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   2280
      Width           =   1095
   End
   Begin VB.TextBox txtDimension 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "2"
      Top             =   480
      Width           =   1335
   End
   Begin MSFlexGridLib.MSFlexGrid grdMatrix 
      Height          =   2775
      Left            =   1440
      TabIndex        =   5
      Top             =   1080
      Width           =   5055
      _ExtentX        =   8916
      _ExtentY        =   4895
      _Version        =   327680
      FixedRows       =   0
      FixedCols       =   0
      BackColorFixed  =   16777215
      BackColorBkg    =   12648447
      WordWrap        =   -1  'True
      BorderStyle     =   0
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   1440
      Width           =   1095
   End
   Begin VB.ComboBox cboLinearAlgebra 
      Height          =   315
      Left            =   2040
      TabIndex        =   3
      Top             =   480
      Width           =   4455
   End
   Begin VB.CommandButton cmdDisplay 
      Caption         =   "&Display"
      Height          =   372
      Left            =   3480
      TabIndex        =   2
      ToolTipText     =   "Display Gauss session"
      Top             =   4200
      Width           =   1095
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   372
      Left            =   5040
      TabIndex        =   1
      ToolTipText     =   "Exit Application"
      Top             =   4200
      Width           =   1092
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "&Execute"
      Height          =   372
      Left            =   1920
      TabIndex        =   0
      ToolTipText     =   "Execute Gauss code"
      Top             =   4200
      Width           =   1095
   End
   Begin VB.Label lblLinearAlgebra 
      Alignment       =   2  'Center
      BackColor       =   &H0080C0FF&
      Caption         =   "Linear Algebra Method"
      Height          =   255
      Left            =   2040
      TabIndex        =   7
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label lblDimension 
      Alignment       =   2  'Center
      BackColor       =   &H0080C0FF&
      Caption         =   "Matrix Dimension"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "frmVB1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdClear_Click()
    grdMatrix.Clear
    cmdExecute.Enabled = False
End Sub

Private Sub cmdDisplay_Click()
    frmVB1.Hide
    frmVB2.cmdDisplay
    frmVB2.Show
End Sub

Private Sub cmdExecute_Click()
    Dim InputMatrix() As Double
    Dim N As Integer
    Dim I, J As Integer
    Dim InputMatrixName As String
    Dim GaussProgram As String
    
    N = Val(txtDimension.Text)
    ReDim InputMatrix(1 To N, 1 To N)
    
    For I = 1 To N Step 1
        grdMatrix.Row = I - 1
        For J = 1 To N Step 1
            grdMatrix.Col = J - 1
            InputMatrix(I, J) = Val(grdMatrix.Text)
        Next J
    Next I
        
    InputMatrixName = "x"
    gematput InputMatrixName, InputMatrix()
    
    Select Case cboLinearAlgebra.ListIndex
        Case 0
            GaussProgram = "c:\engine\prg\balance.prg"
            geexec GaussProgram
        Case 1
            GaussProgram = "c:\engine\prg\cond.prg"
            geexec GaussProgram
        Case 2
            GaussProgram = "c:\engine\prg\crout.prg"
            geexec GaussProgram
        Case 3
            GaussProgram = "c:\engine\prg\hess.prg"
            geexec GaussProgram
        Case 4
            GaussProgram = "c:\engine\prg\lu.prg"
            geexec GaussProgram
        Case 5
            GaussProgram = "c:\engine\prg\null.prg"
            geexec GaussProgram
        Case 6
            GaussProgram = "c:\engine\prg\pinv.prg"
            geexec GaussProgram
        Case 7
            GaussProgram = "c:\engine\prg\qqr.prg"
            geexec GaussProgram
        Case 8
            GaussProgram = "c:\engine\prg\rank.prg"
            geexec GaussProgram
        Case 9
            GaussProgram = "c:\engine\prg\schur.prg"
            geexec GaussProgram
        Case 10
            GaussProgram = "c:\engine\prg\svd.prg"
            geexec GaussProgram
    End Select
            
    cmdDisplay.Enabled = True
    
End Sub

Private Sub cmdExit_Click()
    geclose
    End
End Sub

Private Sub cmdData_Click()
    Dim N As Integer
    Dim I, J As Integer
    Dim Prompt As String
    Dim Mij As String
    
    N = Val(txtDimension.Text)
    
    For I = 1 To N Step 1
        grdMatrix.Row = I - 1
        For J = 1 To N Step 1
            Prompt = "Row #" + str(I) + " - Col #" + str(J)
            Mij = InputBox(Prompt, "Enter Data", "", 500, 5000)
            grdMatrix.Col = J - 1
            grdMatrix.Text = Mij
        Next J
    Next I
    
    cmdExecute.Enabled = True
    
End Sub

Private Sub Form_Load()
    cboLinearAlgebra.AddItem "BALANCE - Balances a matrix"
    cboLinearAlgebra.AddItem "COND - Computes condition number"
    cboLinearAlgebra.AddItem "CROUT - Computes Crout Decomposition"
    cboLinearAlgebra.AddItem "HESS - Computes upper Hessenberg form"
    cboLinearAlgebra.AddItem "LU - Computes LU Decomposition with row pivoting"
    cboLinearAlgebra.AddItem "NULL - Computes orthonormal basis for right null space"
    cboLinearAlgebra.AddItem "PINV - Computes Moore-Penrose pseudo-inverse"
    cboLinearAlgebra.AddItem "QQR - Computes QR decomposition"
    cboLinearAlgebra.AddItem "RANK - Computes rank of a matrix"
    cboLinearAlgebra.AddItem "SCHUR - Computes Schur decomposition"
    cboLinearAlgebra.AddItem "SVD - Computes the singular values"
    cboLinearAlgebra.ListIndex = 0

    cmdDisplay.Enabled = False
    cmdExecute.Enabled = False
    geopen
End Sub

Private Sub txtDimension_Change()
    grdMatrix.Clear
    cmdExecute.Enabled = False
    grdMatrix.cols = Val(txtDimension.Text)
    grdMatrix.rows = Val(txtDimension.Text)
End Sub
