/* 
** BS.PRG  
*/
   
   
call sysstate(24,sysstate(2,0)); 
dlibrary vblink.dll ;
library vblink;
vbl_appname  = &Application;
call vblink;
  
proc (0) = Application;
  local S0,K,sigma,tau,r,b,OptionType,w,d1,d2,Premium;
  
  S0 = getvalue("BS_S0");
  K = getvalue("BS_K");
  sigma = getvalue("BS_sigma");
  tau = getvalue("BS_tau");
  r = getvalue("BS_r");
  b = getvalue("BS_b");
  OptionType = getstring("BS_type");
    
  w = sigma.*sqrt(tau);
  d1 = ( ln(S0./K) + b.*tau )./w + 0.5 * w;  
  d2 = d1 - w;

  if lower(OptionType) $== "put";
    Premium = -S0.*exp((b-r).*tau).*cdfn(-d1) + K.*exp(-r.*tau).*cdfn(-d2);
  else;
    Premium = S0.*exp((b-r).*tau).*cdfn(d1) - K.*exp(-r.*tau).*cdfn(d2);
  endif;  
  
  call sendvalue("BS_premium",Premium);   

  retp;
endp;

