new;
library tsm,optmum,pgraph;
TSMset;


@<--- Data --->@

N = 248;
t = seqa(0,6*pi/N,N+1);
x1 = sin(t);
x2 = cos(2*t);
x3 = rndn(N+1,1)*0.20;

y = x1 + x2 + x3;


@<--- Fourier transform --->@

d = fourier(y);

{r,theta} = topolar(d);


@<--- Inverse Fourier transform --->@

r1 = substute(r, r .> 100, 0);
d1 = tocart(r1,theta);
y1 = real(inverse_fourier(d1));

r2 = substute(r, r .< 100, 0);
d2 = tocart(r2,theta);
y2 = real(inverse_fourier(d2));


graphset;
  begwind;
  window(2,2,0);
    _pdate = ""; _pnum = 2; _pnumht = 0.25;

  setwind(1);
    ytics(-2,1.5,0.5,0);
    xtics(0,20,5,0);
    xy(t,y);

  setwind(2);
    graphset; _pnumht = 0.20; _plctrl = -1;
    polar(r1,theta);

  setwind(3);
    _plctrl = 0;
    polar(r2,theta);

  setwind(4);
    ytics(-2,1.5,0.5,0);
    xtics(0,20,5,0);
    xy(t,y1~y2);

    graphprt("-c=1 -cf=tsm4a.eps");

  endwind;

